# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2015_11_01_preview
  module Models
    #
    # The top level Workspace resource container.
    #
    class Workspace < Resource

      include MsRestAzure

      # @return [EntityStatus] The provisioning state of the workspace.
      # Possible values include: 'Creating', 'Succeeded', 'Failed', 'Canceled',
      # 'Deleting', 'ProvisioningAccount'
      attr_accessor :provisioning_state

      # @return [String] This is a read-only legacy property. It is always set
      # to 'Azure' by the service. Kept here for backward compatibility.
      attr_accessor :source

      # @return [String] This is a read-only property. Represents the ID
      # associated with the workspace.
      attr_accessor :customer_id

      # @return [String] This is a legacy property and is not used anymore.
      # Kept here for backward compatibility.
      attr_accessor :portal_url

      # @return [Sku] The SKU of the workspace.
      attr_accessor :sku

      # @return [Integer] The workspace data retention in days. -1 means
      # Unlimited retention for the Unlimited Sku. 730 days is the maximum
      # allowed for all other Skus.
      attr_accessor :retention_in_days

      # @return [String] The ETag of the workspace.
      attr_accessor :e_tag


      #
      # Mapper for Workspace class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Workspace',
          type: {
            name: 'Composite',
            class_name: 'Workspace',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              source: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.source',
                type: {
                  name: 'String'
                }
              },
              customer_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.customerId',
                type: {
                  name: 'String'
                }
              },
              portal_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.portalUrl',
                type: {
                  name: 'String'
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              retention_in_days: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.retentionInDays',
                constraints: {
                  InclusiveMaximum: 730,
                  InclusiveMinimum: -1
                },
                type: {
                  name: 'Number'
                }
              },
              e_tag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eTag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
